//-----------------------------------------
// Mike Green's Springythingy Lscript

//Notes:
//Sorted object id's.

@version 2.5
@warnings
@script motion
@name Springythingy2
@save relative
// global values go here
// A = old values of mass
// B = new values of mass
// Z = target 

myversion=3;

//3 uses new id fixes in LW to make things more reliable.
//2.8 rewritten, made non-modal and fixed bugs.
//2.7 fixed bone saving bug
//2.6 fixed to work with object ids properly
//2.5 Fixed it to work with motion blur
//2.4 added a starttime so you don't have to have a
//    settle time if you move your object a large distance on frame or so.
//2.3 fixes envelopes so they are actually used! BIG DOH! 
//2.2 fixes envelopes to work again.
//2.1 fixed list entry

velA = <0,0,0>;
velB = <0,0,0>;
posA = <0,0,0>;
posB = <0,0,0>;
posZ = <0,0,0>;
rotB = <0,0,0>;
rotZ = <0,0,0>;
oldtime = 0;

accel = <0,0,0>;
timeA =0;
timeB=0;
timediff=0;

myidoffset=nil;
myobj=nil;
mytgt=nil;

// external controls

ikchoice = true;
mystartpos=<0,0,0>;
mystarttime=0.0;

valnames;
valchan;
val;

mas=1;
lim=2;
spr=3;
dam=4;
b,c;

create:obj      // with the Layout Object Agent argument
//create      // without the Layout Object Agent argument
{
    // one-time initialization takes place here
    myobj=obj;

	valnames[mas]="Mass";
	valnames[lim]="Limit";
	valnames[spr]="SpringConstant";
	valnames[dam]="Damping";

	val[mas]=1.0;
	val[lim]=0.0;
	val[spr]=5.0;
	val[dam]=0.9;

	valchan[mas]=nil;
	valchan[lim]=nil;
	valchan[spr]=nil;
	valchan[dam]=nil;
}

destroy
{
    // take care of final clean-up activities here
}

flags
{ 
    if (ikchoice==true)// and timeB>timeA and timeB!=0)
    {
        return (AFTERIK);
//        return (IA_AFTERIK);
    }
    else
    {
        return;
    }
} 


process: ma, frame, time
{
    // called each time the object's transformational values change
// Do Following calc

    if(mytgt!=nil)
    {
        timeB=Scene().currenttime;
        posZ=mytgt.getWorldPosition(timeB);

        if (timeB<=mystarttime)        //timeB<timeA ||
        	InitBeforeStartTime();
        else
        {
            tval=GetCurrentValues(timeB);
//            tval=val;

        	timediff=timeB-timeA;
            accel=(tval[spr]*(posZ-posA))/tval[mas];
            damp=velA*tval[dam];
            velB=(velA+((accel-damp)*timediff));
            posB=posA + (velB*timediff);
            if (tval[lim]>0)
            {
    // if posB is too far from posZ
                spacediff=(posZ-posB);
                lengthdiff=vmag(spacediff);
                if (lengthdiff>tval[lim])
                {
    				//move it to the limit distance
    				// then back calc velocityB again.
                    
                    multiplier=1-(tval[lim]/lengthdiff);
                    increment=spacediff*multiplier;
                    posC=posB+increment;
                    posB=posC;
                    velB=((posB-posA)/timediff);
                }
            }
        }

        ma.set(POSITION,posB);
        velA=velB;
        posA=posB;
        timeA=timeB;

        thingname=mytgt.name;
	}
	else
		thingname="(none)";

    setdesc("MG Springythingy following "+thingname);
}

InitBeforeStartTime
{
// Initialize if time =0;
            posA=posZ;
            posB=posZ;
            velA = <0,0,0>;
            velB = <0,0,0>;
            accel = <0,0,0>;
            timeA =timeB;
            timediff=0;
}

GetCurrentValues:ptime=0
{
//Set up of variables from envelopes if they exist!
	for(i=1;i<=valnames.size();i++)
	{
		mychan=valchan[i];
		if (valchan[i]!=nil)
        {
           	cval[i]=valchan[i].value(ptime);
        }
        else
            cval[i]=val[i];
   	}
   	if(cval[mas]==0)
   		cval[mas]==1;
   	return(cval);
}

load: what,io
{
//debug();
    if(what == SCENEMODE)   // processing an ASCII scene file
    {
        scene=Scene();
        mytempversion = string(io.read());

        if (mytempversion >= 2.3)
        {

			for(i=1;i<=valnames.size();i++)
			{
            	temp = string(io.read());
            	if (temp =="noenv")
                	val[i]=number(io.read());
            	else
            	{
					channelgroup=myobj.name;
                	valchan[i]=Envelope(valnames[i],CHAN_NUMBER,channelgroup);
        			valchan[i].persist(true);
                	valchan[i].load();
            		temp = string(io.read());
            	}
   			}

           	ikchoicestr = string(io.read());
            if(ikchoicestr == "false")
                ikchoice = false;
            else    
                ikchoice = true;

            myobjid=io.read().asInt();
			if(myobjid==0)
				return;
    		myitem=Mesh(myobjid.asInt());
    		if(!myitem)
    			myitem=Light(myobjid.asInt());
    		if(!myitem)
    			myitem=Camera(myobjid.asInt());
    		if(myitem)
    			mytgt= myitem;

            if(mytempversion >= 2.4)
                mystarttime= number(io.read());
        }
    }
   
}

save: what,io
{
    if(what == SCENEMODE)
    {
        io.writeln(myversion);  
//write settings
		for(i=1;i<=valnames.size();i++)
		{
        	if (valchan[i]==nil)
        	{
            	io.writeln("noenv");
            	io.writeln(val[i]);
        	}
        	else
        	{
            	io.writeln(myobj.name);
            	valchan[i].save();
        	}
  		}

//write other settings

        if(ikchoice!=true)
            io.writeln("false");
        else
            io.writeln("true");

        if (!mytgt)
            io.writeln("0");
        else 
            io.writeln(mytgt.id);

        io.writeln(mystarttime);
    }
}

options
{
    reqbegin("Mike Green's Springythingy Ver:"+myversion);
    reqsize(400,180);

    t1 = ctltab("Controls","Information");
    ctlposition(t1,10,0);


    b[1] = ctlallitems("Item",mytgt);
    ctlposition(b[1],120,27,150,20);
	o1 = ctlbutton("Use current item",150,"GetItem");
    ctlposition(o1,280,27,110,20);

    s1 = ctlsep(9,378);
    ctlposition(s1,9,57,378,5);

	for(i=1;i<=4;i++)
	{
    	c[i] = ctlnumber(valnames[i],val[i]);
    	e[i] = ctlbutton("E",16,"EnvCallback",i.asStr());
    	r[i] = ctlbutton("REMOVE",60,"RemEnv",i.asStr());
    	ctlposition(c[i],50,50+i*20,138,16);
    	ctlposition(e[i],190,50+i*20,16,16);
    	ctlposition(r[i],210,50+i*20,60,16);
 	}

    b[2] = ctlcheckbox("After IK",ikchoice);
    ctlposition(b[2],29,27);

    b[3] = ctlnumber("Start Time(secs)",mystarttime);
    ctlposition(b[3],50,150,138,16);

    t2 = ctltext("Help","Contact: Dodgy@shortbutpurple.fsnet.co.uk",
					"Item: To be followed.",
					"Mass: Weight of the item.",
					"Displacement limit: If zero, does nothing.",
					"                    If non zero, limits the maximum distance from the followed item.",
					"Spring constant: Restoring force multiplier.",
					"Damping: Wobbling falloff.",
					"E : Add envelope",
					"REMOVE: Remove envelope",
					"Start time: Time to commence wobbling from in seconds");

    ctlposition(t2,10,25,208,78);

    ctlrefresh(b[1],"GetValues");
    ctlrefresh(b[2],"GetValues");
    ctlrefresh(b[3],"GetValues");
    ctlrefresh(c[1],"GetValues");
    ctlrefresh(c[2],"GetValues");
    ctlrefresh(c[3],"GetValues");
    ctlrefresh(c[4],"GetValues");

    ctlpage(1,c[1],e[1],r[1],c[2],e[2],r[2],c[3],e[3],r[3],c[4],e[4],r[4],b[1],b[2],b[3],o1,s1);
    ctlpage(2,t2);

    reqopen();
}

GetValues:temp
{
	for(i=1;i<=valnames.size();i++)
	{
    	val[i]=getvalue(c[i]);
	}
    myitem = getvalue(b[1]);
    mystarttime = getvalue(b[3]);
    ikchoice = getvalue(b[2]);

    if (myitem)
      	mytgt=myitem;
    else
        mytgt=nil;
}

GetItem
{
	myitem=Scene().firstSelect();
	if(!myitem || myitem.id == myobj.id)
		return;
	mytgt=myitem;
	reqabort();
	options();
}

EnvCreator: chanid,env_type,env_val
{
//debug();
    if(valchan[chanid]==nil)
    {
        valchan[chanid]=Envelope(valnames[chanid],env_type,myobj.name);
        valchan[chanid].persist(true);
        valchan[chanid].createKey(0,env_val);
    }
    valchan[chanid].edit();

	temp=GetCurrentValues(1);
}


EnvCallback:envid
{
	chanid=envid.asInt();
    EnvCreator(chanid,CHAN_NUMBER,val[chanid]);
}

RemEnv:envid
{
	chanid=envid.asInt();
    if (valchan[chanid]!=nil)
    {
        valchan[chanid]=nil;
    }
}

getagentbyid:id
{
//debug();
    myitem=Mesh(id);
    if(!myitem)
    	myitem=Light(id);
    if(!myitem)
    	myitem=Camera(id);
    if(myitem)
    	return(myitem);
    else
    	return (nil);
    
}













